﻿Option Strict On
Option Explicit On
Imports System.Text.RegularExpressions
<DebuggerNonUserCode()>
Public Class RegExTextBox
   Public Property ErrorColor() As Color
   Protected validationPattern As String
   Public Property ErrorMessage() As String
   Protected mValidationExpression As Regex
   Public ReadOnly Property IsValid() As Boolean
      Get
         If Me.mValidationExpression IsNot Nothing Then
            Return Me.mValidationExpression.IsMatch(Me.Text)
         Else : Return True
         End If
      End Get
   End Property
   Public Property ValidationExpression() As String
      Get
         Return Me.validationPattern
      End Get
      Set(ByVal Value As String)
         Me.mValidationExpression = New Regex(Value)
         Me.validationPattern = Value
      End Set
   End Property
   <DebuggerStepThrough()>
   Protected Overrides Sub OnValidated(ByVal e As EventArgs)
      If Not Me.IsValid Then
         Me.ForeColor = Me.ErrorColor
      Else : Me.ForeColor = DefaultForeColor
      End If
      MyBase.OnValidated(e)
   End Sub
   <DebuggerStepThrough()>
   Public Sub New()
      MyBase.New
      Me.InitializeComponent()
      Me.ErrorColor = Color.Red
   End Sub
End Class